unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, ExtCtrls, TeeProcs, TeEngine, Chart, StdCtrls,
  ComCtrls;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Panel1: TPanel;
    Edit1: TEdit;
    TrackBar1: TTrackBar;
    BAnimate: TButton;
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure BAnimateClick(Sender: TObject);
  private
    { Private declarations }
    procedure Timer1Timer(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Series, TeeVideo;

var Video : TVideoTool;
    Timer1: TTimer;
    DeltaRotate  : Integer;

procedure TForm1.FormCreate(Sender: TObject);
begin
  with Chart1 do
  begin
    Hover.Visible:=false;
    Legend.Visible:=false;
    View3D:=false;
  end;

  with Chart1.AddSeries(TPointSeries) as TPointSeries do
  begin
    FillSampleValues(100);
    Pointer.VertSize:=3;
    Pointer.HorizSize:=3;
  end;

  Edit1.Text:='test.avi';
  TrackBar1.Max:=Chart1[0].Count-1;
  TrackBar1.Frequency:=10;

  Video:=TVideoTool.Create(Self);
  Video.ParentChart:=Chart1;
  Video.FileName:=Edit1.Text;

  Timer1:=TTimer.Create(Self);
  Timer1.Enabled:=False;
  Timer1.Interval:=100;
  Timer1.OnTimer:=Timer1Timer;

  Chart1.Draw;
  Chart1.Axes.Automatic:=false;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if TrackBar1.Position < TrackBar1.Max then
  Begin
    TrackBar1.Position:=TrackBar1.Position + 5;         // Timer trigger 5 times per second so each second 10 more point will become visible
    Application.ProcessMessages;
  end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var i: Integer;
begin
  for i:=0 to Chart1[0].Count-1 do
    if i<=TrackBar1.Position then
      Chart1[0].ValueColor[i]:=clNone
    else
      Chart1[0].ValueColor[i]:=Chart1[0].Color;
end;

procedure TForm1.BAnimateClick(Sender: TObject);
begin
  TrackBar1.Position := 0;
  Application.ProcessMessages;

  Timer1.Enabled := true;                         //enabling the timer

  Video.StartRecording('test.avi');               // Start recording
  while (TrackBar1.Position < TrackBar1.Max) do   // Wait until all point are plotted
  Begin
    Application.ProcessMessages;
    Sleep(500);
  end;

  Timer1.Enabled:=false;
  Video.StopRecording;                            // Stop recording
end;

end.
